﻿using Bizgaze.CRM;
using ChoETL;
using DnsClient;
using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Unibase.Data;
using Unibase.Data.Expressions;
using Unibase.Data.Sql;
using Unibase.Dependency;
using Unibase.Platform.Apps.Managers;
using Unibase.Platform.Data;
using Unibase.Platform.Forms.Providers;
using Unibase.Platform.Keys;
using Unibase.Platform.Series.Managers;

namespace Bizgaze.CRM.Visitors.ActionProviders
{
    public class VisitorStageChangeAndUpDateContacts : BaseFormActionProvider, IFormActionProvider
    {
        public string ControllerClass
        {
            get
            {
                return "Bizgaze.CRM.Visitors.ActionProviders.VisitorStageChangeAndUpDateContacts";

            }
        }
        public string FormActionName
        {
            get
            {
                return "VisitorStageChangeAndUpDateContacts";
            }
        }
        public string Description
        {
            get
            {
                return "Visitor Stage Change And UpDate Contacts";
            }
        }
        public UniqueKey UniqueId
        {
            get
            {
                return Bizgaze.CRM.Actions.VisitorStageChangeAndUpDateContacts;
            }
        }
        public int ActionType
        {
            get
            {
                return (int)Unibase.Platform.Forms.Enums.FormActionProvider.PostAction;
            }
        }
        //public ActionResponse<ExpandoObject> Execute(ActionRequest request, object IdValue, ExpandoObject obj, List<Unibase.Platform.Forms.Requests.DocParameter> docParametersList, ref long defaultPKValue)
        //{
        //    return null;

        //}
        public async Task<ActionResponse<FormActionResponse>> ExecuteAsync(ActionRequest request, FormActionProviderObject providerObject)
        {
            using (var requestTrans = await request.BeginTransactionAsync())
            {
                var IdValue = providerObject.IdValue;
                var srequest = SelectRequest.FromRequest(request);
                var obj = providerObject.RequestObject;
                //var docParametersList = providerObject.DocParametersList;
                //dynamic visitorparam = new Dictionary<string, object>();
                var defaultPKValue = providerObject.DefaultPKValue;
                var stageManager = Unibase.Dependency.DependencyConfig.Resolve<IStageManager>();
                var visitorManager = Unibase.Dependency.DependencyConfig.Resolve<Bizgaze.CRM.Visitors.Managers.IVisitorManager>();
                var dictObj = obj as IDictionary<string, dynamic>;
                List<Unibase.Platform.Forms.Requests.DocParameter> docParameters = dictObj["DocParameters"];
                var connection = GetConnection(request);
                ExpandoObject obj1 = dictObj["RequestObj"];
                var req = obj1 as IDictionary<string, object>;
                var mobileNumber = "";
                var emailId = "";
                //long installedAppId = 0;
                var visitorName = "";
                // var stageStatusName = "";
                var photourl = "";
                var visitorInfo = docParameters.Find(x => x.DocType == "bizgazecrm_visitors");
                // var visitorNumberInfo = docParameters.Find(Y => Y.DocType == "bizgazecrm_visitornumbers");
                //var tenantid = Convert.ToInt64(visitorNumberInfo.Parameters["tenantid"]);
                if (visitorInfo != null)
                {
                    long installedAppId = 0;
                    var stageStatusName = "";
                    var code = "";
                    var _code = "";
                    var visitorIds = Convert.ToInt64(visitorInfo.Parameters["visitorid"]);
                    var visitortype = Convert.ToInt64(visitorInfo.Parameters["visitortype"]);
                    var sel1 = new Unibase.Data.Sql.Select("bizgazecrm_visitors").AllColumns().Where("visitorid", visitorIds);
                    var param = new List<Unibase.Data.Parameter>();
                    param.Add(new Unibase.Data.Parameter("@visitorId", visitorIds));
                    var dt1 = await GetDataTableAsync(srequest, sel1, param);
                    var tenantid = Convert.ToInt32(dt1.Rows[0]["tenantid"]);
                    var _SeriesId = Convert.ToInt64(visitorInfo.Parameters["seriesid"]);
                    var visitorType = Convert.ToInt64(visitorInfo.Parameters["visitortype"]);
                    installedAppId = Convert.ToInt64(visitorInfo.Parameters["installedappid"]);
                    //DateTime CreateDate = Convert.ToDateTime(visitorInfo.Parameters["createddate"]);
                    var visitordata = await visitorManager.GetVisitorByIdAsync(srequest, visitorIds);
                    var _seriesManager = Unibase.Dependency.DependencyConfig.Resolve<Unibase.Platform.Series.Managers.ISeriesManager>();
                    if (visitordata.Result != null)
                    {
                        if (visitorType == 1)
                        {
                            stageStatusName = "CheckIn";
                            code = visitorInfo.Parameters["code"].ToString();
                            string[] Ocode = { };
                            Ocode.Append(code);
                            string[] resultarray = Array.FindAll(Ocode, element => element == "-");
                            if (resultarray.Length > 1)
                            {
                                if (_SeriesId != 0)
                                {
                                    var SeriesCodeInfo = await _seriesManager.GenerateSeriesCodeForQueueAsync(request, _SeriesId, DateTime.Now);
                                    if (SeriesCodeInfo.Status == ResponseStatus.Error)
                                    {
                                        if (requestTrans.StartedLocal) await request.RollbackTransactionAsync();
                                        return ActionResponse<FormActionResponse>.CreateErrorResponse("1", SeriesCodeInfo.Message);
                                    }
                                    else
                                    {
                                        _code = SeriesCodeInfo.Result.SeriesCode;
                                    }
                                }

                            }
                            else
                            {
                                _code = code;
                            }
                            mobileNumber = visitordata.Result.MobileNumber;
                            emailId = visitordata.Result.EmailId;

                            visitorName = visitordata.Result.FullName;
                            photourl = visitordata.Result.PhotoUrl;
                            var stages = await stageManager.GetStageByStageStatusAsync(srequest, installedAppId, stageStatusName);
                            var NewStageIds = stages.Result.StageId;
                            var UpdateStages = new Update("bizgazecrm_visitors").Value("stageid", NewStageIds).Value("lastupdateddate", DateTime.Now).Where(Exp.Eq("visitorId", visitorIds));
                            await _repository.ExecuteAsync(request, UpdateStages);
                            var visitorTypeid = visitordata.Result.VisitorType;
                            var options1 = new EntityOptions()
                            {
                                IsIdentity = true,
                                IsNewEntity = true,
                                TableName = "unibasecmn_users",
                                PkColumn = "userid",
                                IsExcludeFromAudit = false,
                                Id = 0,
                            };
                            dynamic visitorparameters1 = new Dictionary<string, object>();
                            visitorparameters1.Add("username", visitorName);
                            visitorparameters1.Add("createdby", srequest.Identity.UserId);
                            visitorparameters1.Add("tenantid", tenantid);
                            visitorparameters1.Add("createddate", DateTime.Now);
                            visitorparameters1.Add("versionguid", Guid.NewGuid());
                            visitorparameters1.Add("statusid", (int)RowStatus.Active);
                            visitorparameters1.Add("installedappid", installedAppId);
                            visitorparameters1.Add("phonenumber", mobileNumber);
                            visitorparameters1.Add("emailaddress", emailId);
                            var responses = await _repository.SaveAsync(request, options1, visitorparameters1);
                            if (responses.Status == ResponseStatus.Error)
                            {
                                if (requestTrans.StartedLocal) await request.RollbackTransactionAsync();
                                return ActionResponse<FormActionResponse>.CreateErrorResponse("1", "user Are Not Saved");
                            }
                            else
                            {
                                using (var requestTrans1 = await request.BeginTransactionAsync())
                                {
                                    Int64 userid = 0;
                                    {
                                        var data = responses.Result as Dictionary<string, object>;
                                        userid = Convert.ToInt64(data["_Id"]);
                                    }
                                    var options = new EntityOptions()
                                    {
                                        IsIdentity = false,
                                        IsNewEntity = true,
                                        TableName = "bizgazecrm_contacts",
                                        PkColumn = "contactid",
                                        IsExcludeFromAudit = false,
                                        Id = 0,
                                    };
                                    dynamic contactparameters = new Dictionary<string, object>();
                                    contactparameters.Add("contactid", userid);
                                    contactparameters.Add("contactname", visitorName);
                                    //contactparameters.Add("photourl", photourl);
                                    contactparameters.Add("createdby", srequest.Identity.UserId);
                                    contactparameters.Add("createddate", DateTime.Now);
                                    contactparameters.Add("versionguid", Guid.NewGuid());
                                    contactparameters.Add("statusid", (int)RowStatus.Active);
                                    contactparameters.Add("installedappid", installedAppId);
                                    var response = await _repository.SaveAsync(request, options, contactparameters);
                                    if (response.Status == ResponseStatus.Error)
                                    {
                                        if (requestTrans.StartedLocal) await request.RollbackTransactionAsync();
                                        return ActionResponse<FormActionResponse>.CreateErrorResponse("1", "Contacts Are Not Saved");
                                    }
                                    var update = new Update("bizgazecrm_visitors").Value("contactid", userid).Value("code", _code).Where(Exp.Eq("visitorid", visitorIds));
                                    await _repository.ExecuteAsync(request, update);
                                }
                            }

                        }
                        else
                        {

                            var selectvis = new Unibase.Data.Sql.Select("bizgazecrm_visitors").Columns("versionguid").Where("visitorid", visitorIds);
                            var visparam = new List<Unibase.Data.Parameter>();
                            param.Add(new Unibase.Data.Parameter("@visitorId", visitorIds));
                            var datatable = await GetDataTableAsync(srequest, sel1, param);
                            string versionguid = string.Empty;
                            if (datatable != null)
                            {
                               versionguid= datatable.Rows[0]["versionguid"].ToString();
                            }

                            installedAppId = visitordata.Result.Installedappid;
                            stageStatusName = "Pre-Invite";
                            var options = new EntityOptions()
                            {
                                IsIdentity = true,
                                IsNewEntity = false,
                                TableName = "bizgazecrm_visitors",
                                PkColumn = "visitorid",
                                IsExcludeFromAudit = false,
                                Id = defaultPKValue,
                            };
                            var stage = await stageManager.GetStageByStageStatusAsync(srequest, installedAppId, stageStatusName);
                            var NewStageId = stage.Result.StageId;
                            //dynamic contactparameterss = new Dictionary<string, object>();
                            //contactparameters.Add("code",);
                            dynamic contactparameters = new Dictionary<string, object>();
                            //contactparameters.Add("contactid", contactid);
                           // contactparameters.Add("fullname", visitorName);
                            contactparameters.Add("stageid", NewStageId);
                            contactparameters.Add("versionguid", versionguid);
                            defaultPKValue = visitorIds;
                            code = visitorInfo.Parameters["accesscode"].ToString();
                            //var UpdateStage = new Update("bizgazecrm_visitors").Value("stageid", NewStageId).Value("lastupdateddate", DateTime.Now).Where(Exp.Eq("visitorId", visitorIds));
                            var response = await _repository.SaveAsync(request, options, contactparameters);
                        }
                    }
                    var visitorInfos = await visitorManager.GetpreVisitorsAsync(srequest, code);
                    var visitorId = Convert.ToInt64(visitorInfos.Result.VisitorId);
                    var select = new Unibase.Data.Sql.Select("bizgazecrm_visitorcheckout").AllColumns().Where("visitorId", visitorId);
                    var parameters = new List<Unibase.Data.Parameter>();
                    parameters.Add(new Unibase.Data.Parameter("@visitorId", visitorId));
                    var dt = await GetDataTableAsync(srequest, select, parameters);
                    if (dt.Rows.Count == 0)
                    {
                        var vistoroptions = new EntityOptions()
                        {
                            IsIdentity = true,
                            IsNewEntity = true,
                            TableName = "bizgazecrm_visitorcheckout",
                            PkColumn = "visitorcheckoutid",
                            IsExcludeFromAudit = false,
                            Id = 0,
                        };
                        dynamic visitor = new Dictionary<string, object>();
                        visitor.Add("createdby", srequest.Identity.UserId);
                        visitor.Add("checkindate", visitorInfos.Result.CheckInDate);
                        visitor.Add("tenantid", tenantid);
                        visitor.Add("comments", "");
                        visitor.Add("checkoutdate", DateTime.MinValue);
                        visitor.Add("rating", 0);
                        visitor.Add("versionguid", Guid.NewGuid());
                        visitor.Add("uniqueid", _code);
                        visitor.Add("statusid", (int)RowStatus.Active);
                        visitor.Add("installedappid", visitorInfos.Result.Installedappid);
                        visitor.Add("lastupdateddate", DateTime.Now);
                        visitor.Add("visitorid", visitorId);
                        var response1 = await _repository.SaveAsync(request, vistoroptions, visitor);
                        if (response1.Status == ResponseStatus.Error)
                        {
                            if (requestTrans.StartedLocal) await request.RollbackTransactionAsync();
                            return ActionResponse<FormActionResponse>.CreateErrorResponse("1", "Visitor Check Out Data Not Saved");
                        }
                        if (visitortype == 2)
                        {
                            var agreement = true;
                            var UpdateStage = new Update("bizgazecrm_visitors").Value("agreement", agreement).Where(Exp.Eq("visitorid", visitorIds));
                            await _repository.ExecuteAsync(request, UpdateStage);
                        }
                    }
                }
                var returnresponse = new FormActionResponse();
                returnresponse.Obj = dictObj as ExpandoObject;
                returnresponse.PkValue = defaultPKValue;
                return ActionResponse<FormActionResponse>.CreateSuccessResponse("success", returnresponse);
            }
        }

        public List<UniqueKey> AppliedApps
        {
            get
            {
                return new List<UniqueKey>() {
                    Bizgaze.CRM.Actions.VisitorStageChangeAndUpDateContacts,
            };
            }
        }

    }
}
